
--
-- INTERNAL MAIL REDIRECTION
--
ALTER TABLE PGSCHEMA.Puppeteer ADD PuppeteerMailer CHAR(3);
UPDATE PGSCHEMA.Puppeteer  SET PuppeteerMailer='int';
ALTER TABLE PGSCHEMA.Puppeteer  ALTER COLUMN PuppeteerMailer SET NOT NULL;
ALTER TABLE PGSCHEMA.Puppeteer  ALTER COLUMN PuppeteerMailer SET DEFAULT 'int';
ALTER TABLE PGSCHEMA.Puppeteer  ADD CONSTRAINT enumPuppeteerMailer CHECK (PuppeteerMailer IN ('int','ext'));


--
-- PUBLIC SITE MANAGEMENT ADDITION
--
ALTER TABLE public.Site ADD SiteRoot VARCHAR(255);
UPDATE public.Site      SET SiteRoot='/tmp';
ALTER TABLE public.Site ALTER COLUMN SiteRoot SET NOT NULL;

--
--
-- NAME        : Revision
-- REFERENCES  : Work
--
-- DESCRIPTION : Revisions exist for text base galleries only and reflect revisions
--               made to specific works.

CREATE TABLE PGSCHEMA.Revision (
  GalleryID            INT           NOT NULL,
  WorkID               INT           NOT NULL,
  RevisionTimestamp    TIMESTAMP     NOT NULL DEFAULT LOCALTIMESTAMP,
  PuppeteerLogin       VARCHAR(10)   NOT NULL,
  RevisionName         VARCHAR(30)   NOT NULL,
  RevisionText         TEXT,
  CONSTRAINT pkRevision              PRIMARY KEY (GalleryID, WorkID, RevisionTimestamp),
  CONSTRAINT fkRevision_Work         FOREIGN KEY (GalleryID, WorkID)
    REFERENCES PGSCHEMA.Work (GalleryID, WorkID)
      ON DELETE CASCADE
      ON UPDATE CASCADE,
  CONSTRAINT fkRevision_Owner        FOREIGN KEY (PuppeteerLogin)
    REFERENCES PGSCHEMA.Puppeteer (PuppeteerLogin)
      ON DELETE CASCADE
      ON UPDATE CASCADE
) WITHOUT OIDS;

ALTER TABLE PGSCHEMA.Revision              OWNER TO ethereal;

--
-- REMOVE STALE ENTRIES
--
DELETE FROM PGSCHEMA.Tag WHERE TagType='configuration' AND TagName IN ('ErrEMail','ErrMismatch','MsgLocale','MsgSelect','OptMailer','OptPrivacy','OptScope','TagBanAdd','TagBanAddPuppet','TagBanAddTime','TagBanReason','TagBanRem','TagBanTitle','TagCanonAddition','TagCanonList','TagCanonPuppet','TagCanonPuppeteer','TagCanonTitle','TagConfEMail','TagConfPassword','TagConfPrefs','TagConfSuccess','TagContact','TagContactTitle','TagDesignField','TagDesignText','TagDesignTitle','TagEmail','TagEMail','TagFeedAddition','TagFeedCode','TagFeedDate','TagFeedLink','TagFeedListing','TagFeedMax','TagFeedName','TagFeedSource','TagFeedTimestamp','TagFeedTitle','TagFeedView','TagFeedWindow','TagFontTitle','TagForcastCode','TagForcastData','TagForcastStation','TagForcastTitle','TagGummyName','TagGummyPath','TagGummyRem','TagGummyTitle','TagGummyType','TagList','TagLocaleAddition','TagLocaleRem','TagLocaleTitle','TagModACL','TagModAdd','TagModLogin','TagModRem','TagModTitle','TagOptChatPref','TagOptFormat','TagOptIgnore','TagOptJavascript','TagOptMailer','TagOptPrivacy','TagPassword','TagPasswordOld','TagPasswordRepeat','TagPicAdd','TagPicRem','TagPicTitle','TagPrefs','TagPupImgHeight','TagPupImgSize','TagPupImgWidth','TagRealmAccess','TagRealmAltBoard','TagRealmArchive','TagRealmBanner','TagRealmBoard','TagRealmDateLoc','TagRealmDescription','TagRealmFilter','TagRealmFontDef','TagRealmFormat','TagRealmGenre','TagRealmHarass','TagRealmHomepage','TagRealmLanguage','TagRealmLocale','TagRealmRating','TagRealmSample','TagRealmSelect','TagRealmSelectRealm','TagRealmTags','TagRealmVerified','TagTopcAdd','TagTopcEdit','TagTopcRem','TagTopcTitle','TagWarnMsg','TagWarnSelect','TagWarnTitle','TagWordAdd','TagWordRem','TagWordTitle','TmplCanonItem','TmplForcastDetails','TxtSubmitButtonSub','TmplDesign');

--
-- PEOPLE LIKE TO ABUSE
--
ALTER TABLE PGSCHEMA.Realm ALTER RealmDescription TYPE TEXT;